'ping_fmkhz02c.bas
'zustzliche Anzeige unten: kHz bzw Hz
'Verwendung von Teilen des Programmlistings LEDmatrix1.bas
'von Burkhard Kainka,vgl. dazu Beitrge zur Programmierung
'des ATMEGA8 auf der Ping-Pong-Platine in BASCOM AVR
'unter www.elo-web.de
'externer Quarz 8 MHz, mit 2x 22pF
'Hermann Nieder
'Version Januar 2011

$crystal = 8000000
$regfile = "m8def.dat"
$hwstack = 64
$swstack = 64
$framesize = 64
$baud = 9600

Dim Leds(12) As Word
Dim W As Word
Dim D As Byte
Dim N As Word

Dim X As Byte
Dim Y As Byte
Dim Dat As Word
Dim Hbyte As Byte
Dim Hbyte1 As Word
Dim Lbyte As Byte
Dim Dats As Word
Dim H_nib As Byte
Dim H_nib1 As Byte
Dim L_nib As Byte
Dim L_nib1 As Byte
Dim Zeichen As Byte
Dim Splt1 As Word
Dim Splt2 As Word
Dim Splt3 As Word
Dim Splt4 As Word
Dim Splt5 As Word
Dim Splt6 As Word
Dim Splt7 As Word
Dim Splt8 As Word
Dim Splt9 As Word
Dim Splt10 As Word
Dim Splt11 As Word
Dim Splt12 As Word
Dim Splt1_1 As Word
Dim Splt2_1 As Word
Dim Splt3_1 As Word
Dim Tausender As Word
Dim Tausender1 As Word
Dim Hunderter As Word
Dim Hunderter1 As Word
Dim Zehner As Word
Dim Zehner1 As Word
Dim Einer As Word
Dim Timer_2 As Byte
Dim Sekunde As Byte
Dim Frequenz As Word
Dim Z_bit As Bit
Dim Adcwert As Word
Dim Adwert_t As Word
Dim Einheit As Bit
Dim Freqlo As Word
Dim Freqlow As Byte
Dim Freqhi As Word
Dim Freqhigh As Byte
Dim Stdat As Byte



Declare Sub Initialisierung

Declare Sub Led1(byval X As Byte , Byval Y As Byte)
Declare Sub Led0(byval X As Byte , Byval Y As Byte)



Initialisierung

Dim Xx As Single
Dim Yy As Single



Do


Einheit = 0
Timer_2 = 0
Sekunde = 0
Frequenz = 0

Z1:

Enable Timer0

Z_bit = Pind.3
If Z_bit = 0 Then
Goto Z2
End If
If Sekunde = 1 Then
Goto Z4
Else
Goto Z1
End If

Z2:
Z_bit = Pind.3
If Z_bit = 1 Then
Goto Z3
End If
If Sekunde = 1 Then
Goto Z4
Else
Goto Z2
End If
Z3:
Incr Frequenz
If Frequenz < 10000 Then
Goto Z4
End If

Z4:
 If Sekunde < 1 Then
     Goto Z1
     End If
     Disable Timer0

Z5:
     Dat = Frequenz

     Gosub Dez_darst
     Gosub Darst_einheit
     Loop



'Darstellung im Dezimalformat

Dez_darst:
Tausender = Dat / 1000
Zeichen = Tausender

Gosub Darstellung0

Tausender1 = Tausender * 1000
Dat = Dat - Tausender1
Hunderter = Dat / 100
Zeichen = Hunderter

Gosub Darstellung1

Hunderter1 = Hunderter * 100
Dat = Dat - Hunderter1
Zehner = Dat / 10
Zeichen = Zehner

Gosub Darstellung2

Zehner1 = Zehner * 10
Dat = Dat - Zehner1
Einer = Dat
Zeichen = Einer

Gosub Darstellung3
Return


'Anzeige des Kurzzeichens Hz, kHz
'in den unteren 5 Reihen
'Werte werden zu denjenigen von
'Splt1_1, Spl2_1, Spl3_1 sowie Spll4..Splt12 addiert

Darst_einheit:
If Pind.2 = 0 Then
Gosub Hz_zi1
Else
Gosub Khz_zi1
 End If

'Darstellung de Spalten 6..12
Leds(6) = Splt6
Leds(7) = Splt7 + 992
Leds(8) = Splt8 + 128
Leds(9) = Splt9 + 992
Leds(10) = Splt10 + 832
Leds(11) = Splt11 + 704
Leds(12) = Splt12 + 576
Return

'Einheit Hz
Hz_zi1:
Leds(1) = 0 + Splt1_1
Leds(2) = 0 + Splt2_1
Leds(3) = 0 + Splt3_1
Leds(4) = 0 + Splt4
Leds(5) = 0 + Splt5
Return
'Einheit kHz
Khz_zi1:
Leds(1) = 992 + Splt1_1
Leds(2) = 128 + Splt2_1
Leds(3) = 320 + Splt3_1
Leds(4) = 512 + Splt4
Leds(5) = 0 + Splt5
Return
Meghz_zi1:
' Datei: MHz_u
Leds(1) = Splt1_1 + 992
Leds(2) = Splt2_1 + 32
Leds(3) = Splt3_1 + 192
Leds(4) = Splt4 + 32
Leds(5) = Splt5 + 992
Return




'1. Zeichen
Darstellung0:
Gosub Zeichen_z
Splt1_1 = Splt1
Splt2_1 = Splt2
Splt3_1 = Splt3
Return
'2. Zeichen
Darstellung1:                                               '
Gosub Zeichen_z
Splt4 = Splt1
Splt5 = Splt2
Splt6 = Splt3
Return
'3. Zeichen
Darstellung2:
Gosub Zeichen_z
Splt7 = Splt1
Splt8 = Splt2
Splt9 = Splt3
Return
'4. Zeichen
Darstellung3:
Gosub Zeichen_z
Splt10 = Splt1
Splt11 = Splt2
Splt12 = Splt3
Return

Zeichen_z:
Select Case Zeichen
'Zifferndarstellung oben
Case 0:
Splt1 = 14
Splt2 = 17
Splt3 = 14
Case 1:
Splt1 = 16
Splt2 = 31
Splt3 = 16
Case 2:
Splt1 = 24
Splt2 = 21
Splt3 = 19
Case 3:
Splt1 = 17
Splt2 = 21
Splt3 = 27
Case 4:
Splt1 = 7
Splt2 = 28
Splt3 = 4
Case 5:
Splt1 = 23
Splt2 = 21
Splt3 = 8
Case 6:
Splt1 = 14
Splt2 = 21
Splt3 = 8
Case 7:
Splt1 = 1
Splt2 = 29
Splt3 = 3
Case 8:
Splt1 = 10
Splt2 = 21
Splt3 = 10
Case 9:
Splt1 = 6
Splt2 = 21
Splt3 = 14
End Select

Return


Sub Led1(byval X As Byte , Byval Y As Byte)
 If X < 13then
  Select Case Y
    Case 1 : Leds(x).9 = 1
    Case 2 : Leds(x).8 = 1
    Case 3 : Leds(x).7 = 1
    Case 4 : Leds(x).6 = 1
    Case 5 : Leds(x).5 = 1
    Case 6 : Leds(x).4 = 1
    Case 7 : Leds(x).3 = 1
    Case 8 : Leds(x).2 = 1
    Case 9 : Leds(x).1 = 1
    Case 10 : Leds(x).0 = 1
   End Select
  End If
End Sub

Sub Led0(byval X As Byte , Byval Y As Byte)
 If X < 13 Then
  Select Case Y
    Case 1 : Leds(x).9 = 0
    Case 2 : Leds(x).8 = 0
    Case 3 : Leds(x).7 = 0
    Case 4 : Leds(x).6 = 0
    Case 5 : Leds(x).5 = 0
    Case 6 : Leds(x).4 = 0
    Case 7 : Leds(x).3 = 0
    Case 8 : Leds(x).2 = 0
    Case 9 : Leds(x).1 = 0
    Case 10 : Leds(x).0 = 0
   End Select
  End If
End Sub


'******************  Service-Unterprogramme *********************


Sub Initialisierung
  Config Portc = &B00011111

  Ddrb = &B11111111                                         'gendert gegenber Vorlage
  Ddrd = &B11110010
  'Portd.3 = 1
  Config Timer2 = Timer , Prescale = 8
  On Ovf2 Tim2_isr
  Enable Timer2
  Enable Interrupts
  Start Timer2

  Config Timer0 = Timer , Prescale = 256
    Enable Timer0
  Start Timer0
  On Timer0 Tim0_isr

  End Sub


  '8000000:256:250:125=1

  Tim0_isr:
  Timer0 = 6
  Incr Timer_2

  If Timer_2 < 125 Then
  Goto Timer0_end
  End If

  If Timer_2 = 125 Then
  Timer_2 = 0
  Incr Sekunde
  End If
  Timer0_end:
  Return



'******************************* Interrupt - Display ****************************

Dim Vy As Byte
Dim Col As Byte
Dim Portdout As Byte
Dim Portcout As Byte


Tim2_isr:
 '800 s
'Timer2 = 56
Col = Col + 1
If Col = 13 Then Col = 1
Vy = Col + 0
Portd = 0
Portb = 0
Portc = 0
If Col = 1 Then Portb.4 = 0 Else Portb.4 = 1
Portb.3 = 1                                                 'cl
Portb.3 = 0
Portb.2 = 1                                                 'Str
Portb.2 = 0
Portdout = Low(leds(vy))
Portcout = Portdout And 15
Portdout = Portdout And 240
Portd = Portdout
Portc = Portcout
Portb = High(leds(vy))
'Waitms 500
Return


End